Entwurf PfadAnordnung

From FreeCAD Documentation
Jump to navigation Jump to search
This page is a translated version of the page Draft PathArray and the translation is 81% complete.
Other languages:
Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎română • ‎svenska • ‎čeština • ‎русский

Draft PathArray.svg {{{Name/de}}}

Menüeintrag
Entwurf → PfadAnordnung
Arbeitsbereich
Entwurf, Arch
Standardtastenkürzel
None
In der Version eingeführt
-
Siehe auch
Entwurf PfadVerknüpfeAnordnung, Entwurf Anordnung, Entwurf VerknüpfeAnordnung, Entwurf PunktAnordnung


Beschreibung

Das Draft PathArray.svg Entwurf PfadAnordnung Werkzeug platziert Kopien einer ausgewählten Form entlang eines ausgewählten Pfades, der ein Entwurf Draht, ein Entwurf BSpline und ähnliche Kanten sein kann.

Das PfadAnordnungswerkzeug kann auf 2D Formen verwendet werden, die mit der Entwurf Arbeitsbereich erstellt wurden, aber auch auf vielen Arten von 3D Objekten, wie sie mit der Part Arbeitsbereich, PartDesign Arbeitsbereich oder Arch Arbeitsbereichen erstellt wurden.

Um Kopien in einem orthogonalen Anordnung zu positionieren, verwende Entwurf Anordnung; um Kopien an bestimmten Punkten zu positionieren, verwende Entwurf PunktAnordnung; um Kopien oder Klone zu erstellen und diese manuell zu platzieren, verwende Entwurf Bewegen, Entwurf Drehung und Entwurf Klon.

Draft PathArray Example.png

Objekt entlang einer Bahn angeordnet


Anwendung

  1. Wähle ein Objekt aus, das du verteilen möchten.
  2. Wähle ein Pfadobjekt oder einige Kanten aus, entlang derer das Objekt verteilt werden soll.
  3. Drücke die Draft PathArray.svg Entwurf PfadAnordnung Taste.
  4. Das Anordnungsobjekt wird sofort erzeugt. Du musst die Eigenschaften der Anordnung ändern, um die Anzahl und Richtung der erstellten Kopien zu ändern.

Jedes Element in der Anordnung ist ein exakter Klon des ursprünglichen Objekts, aber die gesamte Anordnung wird in Bezug auf Eigenschaften und Aussehen als eine Einheit betrachtet.

Das Basisobjekt sollte um den Ursprung zentriert sein, auch wenn die Bahn irgendwo anders beginnt.

Optionen

Es gibt keine Optionen für dieses Werkzeug. Entweder funktioniert es mit den ausgewählten Objekten oder nicht.

Eigenschaften

  • Daten-EigenschaftGrundlage: gibt das zu duplizierende Objekt im Pfad an.
  • Daten-EigenschaftPfadObj: gibt das Pfadobjekt an.
  • Daten-EigenschaftPfadUnter}: gibt die Unterelemente (Kanten) des Pfadobjekts an. Diese Eigenschaft erscheint noch nicht im Eigenschaftseditor.
  • Daten-EigenschaftZähle: gibt die Anzahl der Kopien des Basisobjekts an.
  • {Daten-EigenschaftAusrichten: wenn sie True ist, werden die Kopien am Pfad ausgerichtet; andernfalls werden sie in ihrer Standardausrichtung belassen.
Hinweis: in bestimmten Fällen erscheint die Form flach, in Wirklichkeit kann sie sich im 3D Raum bewegt haben, ändere also statt einer flachen Ansicht die Ansicht auf axonometrisch.
  • Daten-EigenschaftXlate: gibt einen Translationsvektor (x, y, z) an, um jede Kopie entlang des Pfades zu verschieben.
Hinweis: wenn Daten-EigenschaftAusrichten True ist, ist der Vektor relativ zu den lokalen Tangenten-, Normal- oder Binormalkoordinaten; andernfalls ist der Vektor relativ zu den globalen Koordinaten.

Skripten

Siehe auch: Draft API und FreeCAD Grundlagen Skripten.

Das Pfadanordnungswerkzeug kann in Makros und von der Python Konsole aus mit folgender Funktion verwendet werden:

PathArray = makePathArray(baseobject, pathobject, count, xlate=None, align=False, pathobjsubs=[])
  • Erstellt eine Pfad Anordnungs Objekt aus dem baseobject, indem bis zu Anzahl Kopien entlang des Template:Incode/de platziert werden.
  • Wenn xlate angegeben wird, handelt es sich um einen FreeCAD.Vector, der eine zusätzliche Verschiebung anzeigt, um den Basispunkt der Kopien zu verschieben.
  • Wenn align True ist, werden die Kopien an der Tangente, der Normalen oder dem Binormalen des Template:Incode/de an dem Punkt ausgerichtet, an dem die Kopie platziert wird.

Beispiel:

import FreeCAD,Draft

p1 = FreeCAD.Vector(500, -1000, 0)
p2 = FreeCAD.Vector(1500, 1000, 0)
p3 = FreeCAD.Vector(3000, 500, 0)
p4 = FreeCAD.Vector(4500, 100, 0)
spline = Draft.makeBSpline([p1, p2, p3, p4])
object = Draft.makePolygon(3, 500)

PathArray = Draft.makePathArray(object, spline, 6)

Technische Erklärung für die Ausrichteigenschaft

Wenn DataAlign False ist, ist die Platzierung der kopierten Formen leicht zu verstehen; sie werden einfach an eine andere Position in ihrer ursprünglichen Ausrichtung verschoben.

Align false

Objekt, das entlang eines geschlossenen Pfades in der ursprünglichen Ausrichtung angeordnet ist.


Wenn DataAlign True ist, wird die Positionierung der Formen etwas komplexer:

  1. Zuerst werden Frenet Koordinatensysteme auf dem Pfad aufgebaut: X ist tangential, Z ist normal, Y ist binormal.
  2. Dann wird das Originalobjekt in jedes pfadbegleitende Koordinatensystem kopiert, so dass der globale Ursprung mit dem Ursprung des pfadbegleitenden Koordinatensystems übereinstimmt.
Patharray alignment annotated.png

Objekt angeordnet entlang einer geschlossenen Bahn; Beschreibung der Komponenten und der Bahn


Die folgenden Bilder zeigen, wie die Anordnung erzeugt wird, je nachdem, in welcher Ebene die Bahn liegt.

Bahn in der XY Ebene:

Patharray alignment.png

Objekt, angeordnet entlang einer geschlossenen Bahn, die auf die XY Ebene ausgerichtet ist


Pfad in der XZ Ebene:

Patharray alignment-XZ.png

Objekt angeordnet entlang einer geschlossenen Bahn, die auf die XZ Ebene ausgerichtet ist


Pfad in der YZ Ebene:

Patharray alignment-YZ.png

Objekt angeordnet entlang eines geschlossenen Pfades, der auf die YZ Ebene ausgerichtet ist


Da du den Pfad, aber nicht das Objekt neu orientierst, ist das Ergebnis konsistent: Das Objekt bleibt so am Pfad ausgerichtet, wie es vor der Neuausrichtung des Pfades war.

Editor: Vielen Dank an den Benutzer DeepSOIC für diese Erklärung.

Additional alignment modes and options introduced in v0.19

Original mode (the default) is the historic alignment mode as in version 0.18. It is not really the Frenet alignment. Original mode uses the normal parameter from Draft.getNormal (or the default) as a constant - it does not calculate curve normal. X follows the curve tangent, Y is the normal parameter, Z is X.Cross(Y).

Tangent mode is similar to Original, but includes a rotation to align the Base object's X to the TangentVector before placing copies. After the rotation, Tangent behaves the same as Original. In previous versions this rotation would be performed manually before invoking PathArray.

Frenet mode orients the copies to a coordinate system along the path. X is tangent to curve, Y is curve normal, Z is curve binormal. If a normal can not be computed (ex a straight line), the default is used.

The ForceVertical option applies to Original and Tangent modes. When this option is applied, the normal parameter from Draft.getNormal is ignored. X follows the curve tangent, Z is the VerticalVector property and Y is X.Cross(Z).

Version 18 cycle chain - Original mode

Align false


Railway cross ties (sleepers) - Tangent mode + ForceVertical

Align false


Frenet Mode

Align false